
#                                    __   __  __
#                                    \ \ / / / /
#                                     \ V / / /
#                                      \_/  \/
#
#                                    V E C T O R
#                                   Configuration
#
# ------------------------------------------------------------------------------
# Website: https://vector.dev
# Docs: https://vector.dev/docs/
# ------------------------------------------------------------------------------

# Note: A full config spec is located at ./vector.spec.toml and examples
#       in the ./examples folder.

data_dir = "/var/lib/vector"

[sources.docker_source]
  type = "docker"
  include_containers = ["runner"]

[transforms.log_parse]
  type = "regex_parser"
  inputs = ["docker_source"]
  patterns = ['(?P<timestamp>\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}\.\d{3}Z)\s*(?P<system>[a-zA-Z-]+)\s*>{26}(?P<message>(\r?\n?.*\r?\n?)*)']
  types.timestamp = "timestamp|%F"
  types.system = "string"
  field = "message"
  drop_failed = true

[transforms.log_split]
  type = "split"
  inputs = ["log_parse"]
  drop_field = true
  field = "message"
  field_names = ["message", "session", "request", "response"]
  separator = "========================="
  types.message = "string"
  types.session = "string"
  types.request = "string"
  types.response = "string"

[transforms.clean_session]
  type = "remove_fields"
  inputs = ["log_split"]
  fields = ["session", "file", "source_type", "host", "container_created_at", "container_id", "container_name", "image", "label.com.gitlab.gitlab-runner.job.before_sha", "label.com.gitlab.gitlab-runner.job.ref", "label.com.gitlab.gitlab-runner.job.sha", "label.com.gitlab.gitlab-runner.runner.local_id", "label.com.gitlab.gitlab-runner.type", "label.com.gitlab.gitlab-runner.pipeline.id", "label.com.gitlab.gitlab-runner.project.id", "label.com.gitlab.gitlab-runner.runner.id", "stream", "system"]

[sinks.loki]
  type = "loki"
  inputs = ["clean_session"]
  endpoint = "http://loki:3100"
  healthcheck = true
  encoding.codec = "json"
  labels.key = "value"
  labels.key = "{{ event_field }}"